=== debian/changelog ===
stockfish (17-1) unstable; urgency=medium

  * New upstream version.
  * Standards 4.7.2 (no real change).
  * Depend on debhelper-compat rather than debhelper.

 -- Milan Zamazal <pdm@debian.org>  Sat, 03 May 2025 19:47:24 +0200
