=== debian/control ===
Source: stockfish
Section: games
Priority: optional
Maintainer: Milan Zamazal <pdm@debian.org>
Build-Depends: debhelper-compat (= 10)
Standards-Version: 4.7.2
Homepage: https://stockfishchess.org

Package: stockfish
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: polyglot, xboard | scid
Description: strong chess engine, to play chess against
 free chess engine derived from Glaurung 2.1. It is a chess engine, so it 
 requires an UCI (universal chess interface) compatible GUI like XBoard 
 (with PolyGlot), eboard, Jose, Arena or scid in order to be used comfortably. 
 It is the strongest open source chess engine by october 2009 in the 
 "computer chess rating list" CCRL. Written in C++ it uses multiple threads 
 and cores. It is capable of Chess960 and has experimental support for polyglot 
 opening books.
