## stockfish 17.1

=== debian/changelog ===
stockfish (17.1-0.1~mx23+1) mx; urgency=medium

  * New upstream version.
  * Refresh patches.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 16 Apr 2025 21:08:29 -0700

stockfish (17-0.1~mx23+1) mx; urgency=medium

  * New upstream version.
  * Refresh patches.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 16 Jan 2025 00:38:43 -0800
