=== debian/watch ===
version=3
opts=dversionmangle=s/(\+|\.)dfsg$// \
        https://github.com/official-stockfish/Stockfish/releases .*/sf_?(\d\S*)\.tar\.gz
